#include <stdio.h>
#include <windows.h>

#include <vector>
#include <string>

using namespace std;

typedef unsigned short u16;

u16 jpnMap[0x8000];
u16 korMap[0x8000];

/* 
 * ======  =======
 * 0x00   :  ƴ
 * 0x01   : 
 * 0x02   :  && 
 * > 0x80 :  
 * ==================
 */

vector<u16> jpnList;
vector<u16> korList;

void main(){
	memset(jpnMap,0x00,sizeof(unsigned short)*0x8000);
	memset(korMap,0x00,sizeof(unsigned short)*0x8000);

	FILE * fp = NULL;

	fp=fopen("JP_ALL.txt","rt");
	if(fp==NULL){
		printf("!\n");
		return;
	}

	while(true){
		int lead = fgetc(fp);
		int back = fgetc(fp);

		if(lead==EOF){
			break;
		}

		u16 tmpChar = (u16)lead<<8|back;

		jpnMap[tmpChar-0x8000]=0x01;
	}

	fclose(fp);

	fp=fopen("KR_ALL.txt","rt");
	if(fp==NULL){
		printf("!\n");
		return;
	}

	while(true){
		int lead = fgetc(fp);
		int back = fgetc(fp);

		if(lead==EOF){
			break;
		}

		u16 tmpChar = (u16)lead<<8|back;

		korMap[tmpChar-0x8000]=0x01;
	}

	fclose(fp);

	fp=fopen("JP_Small.txt","rt");
	if(fp==NULL){
		printf("!\n");
		return;
	}

	while(true){
		int lead = fgetc(fp);
		int back = fgetc(fp);

		if(lead==EOF){
			break;
		}

		u16 tmpChar = (u16)lead<<8|back;

		jpnMap[tmpChar-0x8000]=0x02;
		jpnList.push_back(tmpChar);
	}

	fclose(fp);

	fp=fopen("KR_Small.txt","rt");
	if(fp==NULL){
		printf("!\n");
		return;
	}

	while(true){
		int lead = fgetc(fp);
		int back = fgetc(fp);

		if(lead==EOF){
			break;
		}

		u16 tmpChar = (u16)lead<<8|back;

		korMap[tmpChar-0x8000]=0x02;
		korList.push_back(tmpChar);
	}

	fclose(fp);

	int max=0;
	if(korList.size()>jpnList.size())	max=jpnList.size();
	else								max=korList.size();

	for(int i=0;i<max;i++){
		u16 jch=jpnList[i];
		u16 kch=korList[i];

		jpnMap[jch-0x8000]=kch;
		korMap[kch-0x8000]=jch;
	}

	fp=fopen("JP_Map.txt","wt");
	if(fp==NULL){
		printf("!\n");
		return;
	}

	for(int i=0;i<0x8000;i++){
		fprintf(fp,"0x%04X,",jpnMap[i]);
		if(i%16==15){
			fprintf(fp,"\n");
		}
	}

	fclose(fp);

	fp=fopen("KR_Map.txt","wt");
	if(fp==NULL){
		printf("!\n");
		return;
	}

	for(int i=0;i<0x8000;i++){
		fprintf(fp,"0x%04X,",korMap[i]);
		if(i%16==15){
			fprintf(fp,"\n");
		}
	}

	fclose(fp);

}

